#ifndef MD5PASSWORDEDIT_H_INCLUDED
#define MD5PASSWORDEDIT_H_INCLUDED

#include <Wt/WLineEdit>
#include <Wt/WContainerWidget>
#include <Wt/WApplication>
#include <Wt/WSignal>
#include <Wt/WJavaScript>

using namespace Wt;

typedef void (WObject::*WObjectMethod)(std::string);

class MD5PasswordEdit : public WLineEdit
{
public:
    MD5PasswordEdit(WContainerWidget* parent = NULL);
    MD5PasswordEdit(const WT_USTRING& content, WContainerWidget *parent = 0);
    void setListenMethod(EventSignal<WKeyEvent>& incomingSignal, WObjectMethod outgoingMethod, WObject* listener);
    void setListenMethod(EventSignal<WMouseEvent>& incomingSignal, WObjectMethod outgoingMethod, WObject* listener);
private:
    void initialize();
    void calcMD5(std::string passwordInMD5);
    std::string md5HexStr;
    JSlot* md5JSlot;
    JSignal<std::string>* md5JSignal;
};


#endif // MD5PASSWORDEDIT_H_INCLUDED
